unit UManipBits;

interface

  //Attention : le bit de droite a pour index 0

  procedure SetBit (var Valeur: Word; const BitIndex: Byte);
    //Met le bit BitIndex a 1

  procedure ClearBit (var Valeur: Word; const BitIndex: Byte);
    //Met le bit BitIndex a 0

  procedure PermuteBit (var Valeur: Word; const BitIndex: Byte);
    //Inverse la valeur du bit BitIndex

  function IsBitSet (const Valeur : Word; const BitIndex: Byte): Boolean;
    //Renvoie True si le bit BitIndex est a 1


implementation
                                           

procedure SetBit (var Valeur: Word; const BitIndex: Byte);
begin
  Valeur := Valeur or (1 shl BitIndex);
end;


procedure ClearBit (var Valeur: Word; const BitIndex: Byte);
begin
  Valeur := Valeur and not (1 shl BitIndex);
end;


procedure PermuteBit (var Valeur: Word; const BitIndex: Byte);
begin
  Valeur := Valeur xor (1 shl BitIndex);
end;


function IsBitSet (const Valeur : Word; const BitIndex: Byte): Boolean;
begin
  Result := Valeur and (1 shl BitIndex) <> 0;
end;

end.
