{Solution de mick605 (mick605_AT_hotmail.fr)


Notes a propos du SudokuSolver :
--------------------------------

Au dbut, ce solveur devait etre entierement logique. Je ne savais pas rsoudre des grilles
difficiles, mais je connaissait quelques techniques de bases. J'ai cherch sur internet des
mthodes de rsolution, et je suis tomb sur ce site :
  http://vincent.planete.org/sudoku/

C'est a partir de ce site que j'ai commenc a coder mes mthodes. Les noms de ces mthodes
sont tires de ce site.

Le programme est concu pour pouvoir etre adapt pour des sudokus de tailles diffrentes.
Pour cela, il suffit de modifier les constantes dclares en dbut d'unit USudokuResolution

J'ai ensuite ajout un solveur brute force pour rsoudre toutes les grilles.
Je voulais proposer un mode logique, un mode BF (bruteforce), et un mode 2, ce dernier devrait
etre plus rapide que les deux premiers. Or, mon dernier solveur BF est plus rapide que mon logique.



Units :
--------

USudoku : C'est l'unit principale, dans laquelle les procedures lies aux composants sont dclares.

USudokuResolution : C'est l'unit qui s'occupe de la rsolution logique et brute force du sudoku.
                    Tous les types y sont dclars

USudokuNouveau : C'est l'unit lie a la form "Nouvelle Grille"

UManipBits : C'est une unit qui permet de manipuler facilement les bits d'un entier. Ces fonctions
             sont courtes, mais je les laisse dans une unit a part pour que le code soit
             plus lisible.



Structure des variables :
-------------------------

Ces types sont dclars dans USudokuResolution.

Pour rsoudre cette grille, j'ai imagin une mthode de reprage se basant sur des zones :
Chaque case pouvait etre repre par une zone, un numro de zone et un index dans cette zone.
Exemple :
  la case situe en 6eme colonne, 3eme ligne peut etre repre par :
    Ligne numro 3 position 6 (ou ligne,3,6), mais aussi
    colonne numro 6 position 3 (ou colonne,6,3), ou
    bloc numro 2 position 9 (ou bloc,2,9)

J'appelerai par la suite ce reprage (Zone,NoElement,Index).
J'ai donc cr un tableau de pointeurs a 3 dimensions : [TZone, 1..9, 1..9],
et associ ce tableau a la grille de sudoku.

Chaque case est un record compose d'un Word et d'un boolean. Dans le Word, chaque bit
correspond a un candidat possible
Exemple :
    si Cand vaut 58, en binaire on a : 00000000 00111010
   donc les candidats possibles sont : XXXXXXX    654 2         (les X sont les bits non utiliss)

Il y a aussi un boolean, qui contient si la valeur est place ou non (j'aurais pu utiliser
un bit de Cand)


J'ai ensuite rajout un tableau Occurence, qui contient le nombre de fois qu'une valeur est
contenue dans une zone. Ce tableau est a 3 dimensions, et se compose : Zone, NoElement, Valeur
Ainsi, la case Occurence[zsBloc,4,9] contient le nombre de 9 dans le bloc 4. (Ce tableau permet
d'viter de compter "manuellement" le nombre de 9 dans le bloc 4 par exemple). Ce tableau est
maintenu a jour grace a la procedure EnleverCandidat.


Vocabulaire :
-------------

Un lment : un ensemble de cases de la grille, soit une ligne, soit une colonne, soit
             un bloc. Il est dfini par un NoElement, et un type de zone (TZone). La
             grille contient 9*3 lements. (pour une grille 9*9)

NoElement  : le numro de l'lment. Avec un TZone, il permet de dfinir un lment
             Les lments sont numrotes de gauche a droite pour les colonnes,
             de haut en bas pour les lignes, et de gauche a droite puis de haut en bas
             pour les blocs.

TZone      : un type de zone parmi zsLigne, zsColonne, zsBloc


Index      : le numro de case dans un lment. Dans chaque lment, les indexs sont
             numrotes de gauche a droite et de haut en bas.



Structure du programme :
------------------------

Ces methodes sont dclares dans USudokuResolution.

Tout d'abord, j'ai dcid que je proposerais un mode tape par tape, donc je ne pouvais
pas faire de mthodes de rsolution qui s'appelent entre elles (cette technique aurait
t plus rapide).

Chaque mthode (de rsolution) est compose de plusieurs procedures (en gnral) :

TesterXXXXX : Cette fonction s'occupe d'appeler la fonction XXXXX en lui donnant les
              parametres appropris :
              Par exemple, elle lui donne toutes les zones a tester. Elle s'arrete ds
              qu'une fonction XXXXX trouve quelque chose

XXXXX :       Cette fonction est celle qui fait les calculs. Elle ne s'occupe que d'une
              partie de la grille.

MessXXXXX :   Cette procedure affiche simplement le message dans la variable EtapesResolution

D'autres fonction peuvent etre appeles par XXXXX.



Remarques sur le Sudoku en gnral :
------------------------------------

Voici quelques informations que j'ai trouv a propos du sudoku (quelques unes sont sur le forum)

- Beaucoup de mthodes fonctionnent de la meme maniere, il est possible de les regrouper
  en une seule fonction (souvent rcurente) :
    * Candidats doubles, triples, quadruples, etc.  deviennent Candidats Niemes
    * Paires caches, triplets, quadruplets etc.    deviennent Niemes Cachs
    * X-Wing, etoiles a 3, 4, 5 branches            deviennent Etoile a N Branches

  (voir le site http://vincent.planete.org/sudoku/)

- Les Candidats Niemes et les Niemes Cachs sont lis : dans une zone contenant X cases vides,
  checher un candidat Pieme revient a chercher un (X-P)ieme Cach

- Dans un sudoku de dimension X, chercher une toie a P branches revient a chercher une
  toile a (X-P) branches

- Chercher un emplacement unique dans une zone a X cases vides revient a chercher un
  Candidat (X-1)ieme, ou un 1 ieme Cach


Bugs :
------

Il me reste quelques bugs que je n'ai pas russi a supprimer :

Quand une grille est affiche, et quel'on dplace la fiche de maniere a la
faire sortir de l'cran, les chiffres s'effacent ! C'est normal parce que je dessine sur
le Canvas de la grille. Mais quand je modifie l'venement OnDrawCell, si cet evenement
est trop long, l'venement n'est pas appel pour toutes les cases ... J'ai donc mis un
bouton actualiser l'affichage !

Quand on ouvre ce projet sur Delphi 2005, la form principale mesure 420 de haut, alors
qu'elle devrait faire 440. Si ca arrive, il faut la modifier manuellement. Meme en
enregistrant, la fiche garde 420 comme taille ...



}
unit USudoku;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, ExtDlgs, XPMan, ClipBrd, Menus, ShellApi;

type
  TFSudoku = class(TForm)
    OpenTextFileDialog1: TOpenTextFileDialog;
    SaveTextFileDialog1: TSaveTextFileDialog;
    Label1: TLabel;
    XPManifest1: TXPManifest;
    CandidatsGrid: TStringGrid;
    StringGrid1: TStringGrid;
    StringGrid2: TStringGrid;
    Edit1: TEdit;
    Etapes: TMemo;
    SudokuGrid: TDrawGrid;
    Memo1: TMemo;
    CheminFichier: TLabel;
    ActAffich: TButton;
    MainMenu1: TMainMenu;
    Fichier1: TMenuItem;
    NouvelleGrille1: TMenuItem;
    ChargeruneGrille1: TMenuItem;
    SauverlaGrille1: TMenuItem;
    N1: TMenuItem;
    Quitter1: TMenuItem;
    Edition1: TMenuItem;
    EtapeparEtape1: TMenuItem;
    Rsoudre1: TMenuItem;
    N2: TMenuItem;
    Copier1: TMenuItem;
    Vider1: TMenuItem;
    Paramtres1: TMenuItem;
    Afficherlestapes1: TMenuItem;
    Montrerlescandidats1: TMenuItem;
    UnCoup: TButton;
    Resoudre: TButton;
    Vider: TButton;
    Label2: TLabel;
    Rsolutionlogiqueseulement1: TMenuItem;
    RsolutionBruteForce1: TMenuItem;
    RLogique: TButton;
    RBruteForce: TButton;
    Aide1: TMenuItem;
    procedure Aide1Click(Sender: TObject);
    procedure RsolutionBruteForce1Click(Sender: TObject);
    procedure Rsolutionlogiqueseulement1Click(Sender: TObject);
    procedure Quitter1Click(Sender: TObject);
    procedure Montrerlescandidats1Click(Sender: TObject);
    procedure Afficherlestapes1Click(Sender: TObject);
    procedure Rsoudre1Click(Sender: TObject);
    procedure EtapeparEtape1Click(Sender: TObject);
    procedure Vider1Click(Sender: TObject);
    procedure Copier1Click(Sender: TObject);
    procedure SauverlaGrille1Click(Sender: TObject);
    procedure ChargeruneGrille1Click(Sender: TObject);
    procedure NouvelleGrille1Click(Sender: TObject);
    procedure SudokuGridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure ActAffichClick(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;


var
  FSudoku: TFSudoku;     
  SudokuInit : String;


implementation

uses USudokuNouveau, USudokuResolution, UManipBits;

{$R *.dfm}



type
  TAlignementVertical=(alVTop,alVCenter,alVBottom);
  TAlignementHorizontal=(alHLeft,alHCenter,alHRight);
  TJustification=(JustLeft,JustCenter,JustRight);

const ZoneToStr : array [TZone] of String = (' la colonne ', ' la ligne ', ' le bloc ');
      clSurbrillance = 9240575;       //240,240,120
      clGrisZone = 15790320;          //240,240,240


var
  Sudoku : TGrilleSudoku;
            //Contient toute la grille du sudoku (0 signifie vide)

  Occurence : TOccurence;
           //Occurence contient le nb de V dans la zone numro N
           //   Exemple : Occurence[zsLigne,2,6] contient le nombre de 6 dans la ligne 2)

  PointeursSudoku : PZonesSudoku;



  NbCasesVides : Byte;



           


function LCToBloc (Ligne, Colonne : TSmallNum) :TSmallNum;
//Recupere le numro du bloc associ a la ligne et colonne
//Les blocs sont numrots :
//  1 2 3
//  4 5 6
//  7 8 9

begin
  Result:=((Ligne-1) div 3)*3 + ((Colonne-1) div 3) + 1;
end;





procedure IndexToPosition (const Index, NoElement : TSmallNum; const Zone : TZone; out Ligne, Colonne : TSmallNum);
//Transforme des coordonnes Index, NoElement en Ligne, Colonne

begin
  case Zone of
    zsLigne   : begin
                  Ligne:=NoElement;
                  Colonne:=Index;
                end;
    zsColonne : begin
                  Ligne:=Index;
                  Colonne:=NoElement;
                end;
    zsBloc    : begin
                  Ligne:=((NoElement-1) div 3)*3+(Index-1) div 3+1;
                  Colonne:=((NoElement-1) mod 3)*3+(Index-1) mod 3 +1;
                end;
  end;
end;






{------------------------------------------------------------}
{                                                            }
{             Procedures associees a l'affichage             }
{                                                            }
{------------------------------------------------------------}





//Voir FAQ Delphi de www.developpez.com pour cette fonction :
//URL : http://delphi.developpez.com/faq/?page=typechaine#dimensionstexte
Function TextSize(Phrase : string; Police : TFont = nil) : TPoint;
var
  DC: HDC;
  Rect: TRect;
  C : TBitmap;
begin
  C := TBitmap.create;
  if police <> nil then  C.canvas.Font := police;

    Rect.Left := 0;
    Rect.Top:=0;
    Rect.Right:=0;
    Rect.Bottom:=0;
    DC := GetDC(0);
    C.Canvas.Handle := DC;
    DrawText(C.Canvas.Handle, PChar(Phrase), -1, Rect, (DT_EXPANDTABS or DT_CALCRECT));
    C.Canvas.Handle := 0;
    ReleaseDC(0, DC);
    result.X:=Rect.Right-Rect.Left;
    result.Y:=Rect.Bottom-Rect.Top;
    C.Free;
end;





//Notre procedure d'affichage de texte multiligne
procedure DessineTexteMultiligne(AString: string;ACanvas:TCanvas;ARect: TRect;
                       AlignementHorizontal:TAlignementHorizontal;
                       AlignementVertical:TAlignementVertical;
                       TextJustification:TJustification);
var
  AHeight,AWidth:integer;
  Rect :TRect;
  ATop,ALeft,H,W:Integer;
  JustificationDuTexte:Integer;
  MyRgn:HRGN;
begin
  with ACanvas do
  begin
    Lock;
    AHeight:=ARect.Bottom-ARect.Top;

    AWidth:=ARect.Right-ARect.Left;
    //on calcule la taille du rectangle dans lequel va tenir le texte
    W:=TextSize(AString,ACanvas.Font).X;
    H:=TextSize(AString,ACanvas.Font).Y;

    //on calcule la position (Haut,Gauche) du rectangle dans lequel va tenir le texte
    //en fonction de l'alignement horizontal et vertical choisi
    ATop:=ARect.Top;
    ALeft:=ARect.Left;


    case AlignementVertical of
      alVBottom : ATop:=ARect.Bottom-H;
      alVCenter : ATop:=ARect.Top+((AHeight-H) div 2);
      alVTop    : ATop:=ARect.Top;
    end;

    case AlignementHorizontal of
      alHLeft  : ALeft:=ARect.Left;
      alHCenter: ALeft:=ARect.Left+(AWidth-W) div 2;
      alHRight : ALeft:=ARect.Right-W;
    end;

    //Fin du calcul du rectangle, on met le resultat dans Rect
    Rect:=Bounds(ALeft,ATop,W,H);

    //On remplit le rectangle de la zone sinon on voit le texte que delphi  dessin
    FillRect(ARect);

    //On dtermine les paramtres de justification  passer  Windows
    JustificationDuTexte:=DT_CENTER;
    case TextJustification of
      JustLeft  : JustificationDuTexte:=DT_LEFT;
      JustCenter: JustificationDuTexte:=DT_CENTER;
      JustRight : JustificationDuTexte:=DT_RIGHT;
    end;

    //Si le texte est plus grand que notre zone, on prend cette prcaution (Clipping)
    with ARect do MyRgn :=CreateRectRgn(Left,Top,Right,Bottom);
    SelectClipRgn(Handle,MyRgn);

    //On dessine le texte
    DrawText(Handle,PChar(AString),-1,Rect,JustificationDuTexte or DT_NOPREFIX or DT_WORDBREAK );

    //On a plus besoin de la zone de clipping
    SelectClipRgn(Handle,0);
    DeleteObject(MyRgn);
    Unlock;
  end;
end;




function CandToStr (C : TEnsemble) : String;
//Transforme les candidats Ligne colonne en chaine : utile pour l'affichage
var V : TSmallNum;
begin
  Result:='';
  if FSudoku.MainMenu1.Items[2].Items[1].Checked then         //si on affiche les candidats
  begin
    for V:=0 to TAILLE_SUDOKU-1 do
      if IsBitSet(C,V) then Result:=Result+IntToStr(V+1)
                       else Result:=Result+' ';

    Result:=Result[1]+'  '+Result[2]+'  '+Result[3]+#13+
            Result[4]+'  '+Result[5]+'  '+Result[6]+#13+
            Result[7]+'  '+Result[8]+'  '+Result[9];
  end;
end;




function ValToStr (C : TEnsemble) : String;
//Transforme les candidats Ligne colonne en chaine : utile pour l'affichage
var V : TSmallNum;
begin
  Result:='';
  for V:=0 to TAILLE_SUDOKU-1 do
    if IsBitSet(C,V) then
      Result:=IntToStr(V+1);
end;




procedure AfficherUneCase (Ligne, Colonne : integer; Couleur : TColor);
begin
  with FSudoku.SudokuGrid do
  begin
    Canvas.Brush.Color:=Couleur;

    if Sudoku[Ligne,Colonne].Trouve then
    begin
      Canvas.Font.Size:=13;
      Canvas.Font.Style:=[fsBold];
      DessineTexteMultiligne(ValToStr(Sudoku[Ligne,Colonne].Cand),Canvas,CellRect(Colonne-1,Ligne-1),alHCenter,alVCenter,JustCenter);
    end
    else
    begin
      Canvas.Font.Size:=7;
      Canvas.Font.Style:=[];
      DessineTexteMultiligne(CandToStr(Sudoku[Ligne,Colonne].Cand),Canvas,CellRect(Colonne-1,Ligne-1),alHCenter,alVCenter,JustCenter);
    end;
  end;
end;





procedure Afficher;
//Affiche le tableau 'Sudoku' dans la grille 'SudokuGrid'

var i,j : TSmallNum;
    Color : TColor;
begin
  FSudoku.SudokuGrid.Canvas.Font.Color:=clBlack;
  for j:=1 to TAILLE_SUDOKU do
    for i:=1 to TAILLE_SUDOKU do
    begin
      if Odd(LCToBloc(i,j)) then Color:=clGrisZone
                            else Color:=clWhite;
      AfficherUneCase(i,j,Color);
    end;
end;





procedure AfficherCandidats;                 //affiche le tableau Candidats ( effacer)
var i,j : TSmallNum;
    C : TSmallNum;
    Txt : String;

const
  CandidatToStr : array [TSmallNum] of string = ('','1','2','3','4','5','6','7','8','9');

begin
  for i:=1 to 9 do
    for j:=1 to 9 do
    begin
      Txt:='';
      for C := 0 to 8 do
        if IsBitSet(Sudoku[i,j].Cand,C) then
          Txt:=Txt+CandidatToStr[C+1];
      FSudoku.CandidatsGrid.Cells[j-1,i-1]:=Txt;
    end;
end;





procedure AfficherOccurence;       //affiche le tableau Occurence ( effacer)
var i, V : TSmallNum;
begin
  If (Length(FSudoku.Edit1.Text)=1) and (FSudoku.Edit1.Text[1] in ['1'..'9']) then
  begin
    V:=StrToInt(FSudoku.Edit1.Text[1]);
    for i:=1 to 9 do
      begin
        FSudoku.StringGrid2.Cells[i-1,0]:=IntToStr(Occurence[zsColonne,i,V]);
        FSudoku.StringGrid1.Cells[0,i-1]:=IntToStr(Occurence[zsLigne,i,V]);
      end;
  end;
end;






procedure TFSudoku.SudokuGridDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
begin
  if Odd(LCToBloc(ARow+1,ACol+1)) then SudokuGrid.Canvas.Brush.Color:=clGrisZone
                                  else SudokuGrid.Canvas.Brush.Color:=clWhite;
  SudokuGrid.Canvas.FillRect(Rect);
end;





procedure TFSudoku.ActAffichClick(Sender: TObject);
begin
  Afficher;
end;





{------------------------------------------------------------}
{                                                            }
{  Procedures associees a l'enregistrement et au chargement  }
{                                                            }
{------------------------------------------------------------}


procedure TFSudoku.FormCreate(Sender: TObject);
var i,j : TSmallNum;
begin
  PointeursSudoku:=CreerPointeursZonesSudoku(Sudoku);            //on cre les pointeurs une fois seulement !
  for i:=1 to TAILLE_SUDOKU do
    for j:=1 to TAILLE_SUDOKU do
    begin
      if Odd(LCToBloc(i,j)) then SudokuGrid.Canvas.Brush.Color:=clGrisZone
                            else SudokuGrid.Canvas.Brush.Color:=clWhite;
      SudokuGrid.Canvas.FillRect(SudokuGrid.CellRect(i-1,j-1));
    end;
end;






procedure MemoNouveauSudoku (Nom : String);
//Efface et raffiche le mmo 'Etapes'

begin
  FSudoku.Etapes.Clear;
  FSudoku.Etapes.Lines.Add('------------- Nouveau Sudoku -------------');
  if Nom<>'' then FSudoku.Etapes.Lines.Add('Charg a partir de '+Nom);
  FSudoku.Etapes.Lines.Add('');
end;





procedure ChargerFichierDansSudoku (NomFichier : string);
//Initialise les tableaux et enregistre le fichier dans le tableau sudoku
var Lignes : TStringList;
    NoLigne : Byte;
    Txt : String;
begin
  Initialiser(Sudoku,Occurence);

  Lignes:=TStringList.Create;
  Lignes.LoadFromFile(NomFichier);
  Txt:='';
  for NoLigne:=0 to Lignes.Count-1 do
  begin
    Txt:=Txt+Lignes.Strings[NoLigne];
    if Length(Txt)>(TAILLE_SUDOKU*TAILLE_SUDOKU) then Break;
  end;
  Lignes.Free;

  SudokuInit:=Txt;
  NbCasesVides:=EnregistrerTableau(SudokuInit,PointeursSudoku,Occurence);
end;




procedure TFSudoku.ChargeruneGrille1Click(Sender: TObject);
//Si l'utilisateur ne ferme pas la boite de dialogue,
//Initialise les tableaux, le mmo 'Etapes', le label CheminFichier, la SaveDialog
//et enregistre le fichier dans 'Sudoku', puis affiche
var NomFichier : string;
begin
  if OpenTextFileDialog1.Execute then
  begin
    CheminFichier.Caption:=OpenTextFileDialog1.FileName;
    ChargerFichierDansSudoku(OpenTextFileDialog1.FileName);
    NomFichier:=ExtractFileName(OpenTextFileDialog1.FileName);
    Delete(NomFichier,Length(NomFichier)-Length(ExtractFileExt(NomFichier))+1,Length(ExtractFileExt(NomFichier)));
    MemoNouveauSudoku(NomFichier);
    Afficher;
    AfficherCandidats;
    AfficherOccurence;
    SaveTextFileDialog1.FileName:='Solution de '+NomFichier;
    UnCoup.Enabled:=True;
    MainMenu1.Items[1].Items[0].Enabled:=True;
    Resoudre.Enabled:=True;
    MainMenu1.Items[1].Items[1].Enabled:=True;
    RLogique.Enabled:=True;
    MainMenu1.Items[1].Items[2].Enabled:=True;
    RBruteForce.Enabled:=True;
    MainMenu1.Items[1].Items[3].Enabled:=True;
    MainMenu1.Items[1].Items[5].Enabled:=True; //Copier
    MainMenu1.Items[1].Items[6].Enabled:=False; //Vider
    Vider.Enabled:=False;
    ActAffich.Enabled:=True;
  end;
end;


function ValeurCaseToStr (C : TCaseSudoku) : string;
begin
  if C.Trouve then
    Result:=ValToStr(C.Cand)
  else
    Result:='0';
end;



procedure TFSudoku.SauverlaGrille1Click(Sender: TObject);
//Sauvegarde dans un fichier .txt  le tableau 'Sudoku'

var Fichier : TStrings;
        i,j : TSmallNum;
        Txt : String;
begin
  if SaveTextFileDialog1.Execute then
  begin
    Fichier:=TStringList.Create;

    for j:=1 to TAILLE_SUDOKU do
    begin
      Txt:='';
      for i:=1 to TAILLE_SUDOKU do
        Txt:=Txt+ValeurCaseToStr(Sudoku[i,j]);
      Fichier.Add(Txt)
    end;
    Fichier.SaveToFile(SaveTextFileDialog1.FileName+'.txt');
    Fichier.Free;
  end;
end;





procedure TFSudoku.Vider1Click(Sender: TObject);
//Vide la grille et ne laisse que les valeurs de dpart
var NomFichier : string;
begin
  Initialiser(Sudoku,Occurence);
  NbCasesVides:=EnregistrerTableau(SudokuInit,PointeursSudoku,Occurence);

  NomFichier:=ExtractFileName(OpenTextFileDialog1.FileName);
  Delete(NomFichier,Length(NomFichier)-Length(ExtractFileExt(NomFichier))+1,Length(ExtractFileExt(NomFichier)));
  MemoNouveauSudoku(NomFichier);

  Afficher;

  UnCoup.Enabled:=True;
  MainMenu1.Items[1].Items[0].Enabled:=True;
  Resoudre.Enabled:=True;
  MainMenu1.Items[1].Items[1].Enabled:=True;
  RLogique.Enabled:=True;
  MainMenu1.Items[1].Items[2].Enabled:=True;
  RBruteForce.Enabled:=True;
  MainMenu1.Items[1].Items[3].Enabled:=True;
  MainMenu1.Items[1].Items[5].Enabled:=True; //Copier
  MainMenu1.Items[1].Items[6].Enabled:=False; //Vider
  Vider.Enabled:=False;
end;





procedure TFSudoku.NouvelleGrille1Click(Sender: TObject);
begin
  if FNouveau.ShowModal=idOk then
  begin
    Initialiser(Sudoku,Occurence);
    NbCasesVides:=EnregistrerTableau(SudokuInit,PointeursSudoku,Occurence);

    MemoNouveauSudoku('');

    CheminFichier.Caption:='Nouveau Sudoku';
    Afficher;
    AfficherCandidats;
    AfficherOccurence;
    SaveTextFileDialog1.FileName:='Solution';

    UnCoup.Enabled:=True;
    MainMenu1.Items[1].Items[0].Enabled:=True;
    Resoudre.Enabled:=True;
    MainMenu1.Items[1].Items[1].Enabled:=True;
    RLogique.Enabled:=True;
    MainMenu1.Items[1].Items[2].Enabled:=True;
    RBruteForce.Enabled:=True;
    MainMenu1.Items[1].Items[3].Enabled:=True;
    MainMenu1.Items[1].Items[5].Enabled:=True; //Copier
    MainMenu1.Items[1].Items[6].Enabled:=False; //Vider
    Vider.Enabled:=False;
    ActAffich.Enabled:=True;
  end;
end;






procedure ReglerTailleForm(Affich : boolean);
begin
  FSudoku.Etapes.Visible:=Affich;
  if Affich then
    FSudoku.Width:=933
  else
    FSudoku.Width:=532;
end;





procedure TFSudoku.Afficherlestapes1Click(Sender: TObject);
begin
  MainMenu1.Items[2].Items[0].Checked:=not(MainMenu1.Items[2].Items[0].Checked);
  ReglerTailleForm(MainMenu1.Items[2].Items[0].Checked);
end;





procedure TFSudoku.Montrerlescandidats1Click(Sender: TObject);
begin
  MainMenu1.Items[2].Items[1].Checked:=not(MainMenu1.Items[2].Items[1].Checked);
  Afficher;
end;





{------------------------------------------------------------}
{                                                            }
{            Proceduress associees a la resolution           }
{                                                            }
{------------------------------------------------------------}



var
  NoLigneSeul       : TSmallNum = 1;
  NoElemSeul        : TSmallNum = 1;
  NoElemInteraction : TSmallNum = 1;
  NoElementNieme    : TSmallNum = 1;
  ValNBranche       : TSmallNum = 1;





procedure AfficherSurbrillance(Res : TResultat);
var Index, Ligne, Colonne, NoElem : TSmallNum;
begin
  for NoElem:=0 to TAILLE_SUDOKU do
    if IsBitSet(Res.NoElements,NoElem) then
    begin
      if Res.Index <> 0 then
      begin
        IndexToPosition(Res.Index,NoElem+1,Res.Zone,Ligne, Colonne);
        AfficherUneCase(Ligne,Colonne,clSurbrillance);
      end
      else
      for Index:=1 to TAILLE_SUDOKU do
      begin
        IndexToPosition(Index,NoElem+1,Res.Zone,Ligne, Colonne);
        AfficherUneCase(Ligne,Colonne,clSurbrillance);
      end;
    end;
end;





procedure MettreBoutonsResolution(Etat : boolean);
begin
  FSudoku.MainMenu1.Items[1].Items[1].Enabled:=Etat; //Resoudre
  FSudoku.MainMenu1.Items[1].Items[2].Enabled:=Etat; //Resoudre
  FSudoku.MainMenu1.Items[1].Items[3].Enabled:=Etat; //Resoudre
  FSudoku.RLogique.Enabled:=Etat;
  FSudoku.RBruteForce.Enabled:=Etat;
  FSudoku.Resoudre.Enabled:=Etat;
end;





function FaireUnCoup (var Grille : PZonesSudoku; var Occur : TOccurence; AfficherGrille, SauverEtapes : Boolean) : Boolean;
{Teste les diffrentes fonctions de la plus rapide a la plus lente.
si un test est concluant, alors ca s'arrete !
Affichergrille dfinit si on doit afficher la grille ou pas
NoLigneSeul, NoElemSeul, NoElemInteraction et NoElementNieme dfinissent les numros
des lments a partir desquels il faut commencer la recherche.
on pourrait simplement mettre 1 a la place, mais il y aurait beaucoup de calculs inutiles !
Ces variables vont de 1  9       }

var Res : TResultat;
begin
  AfficherEtapesResolution:=SauverEtapes;
  begin
    Res:=TesterCandidatSeul(Grille,Occur,NoLigneSeul);
    if Res.NoElements=0 then
      Res:=TesterEmplacementUnique(Grille,Occur,NoElemSeul);

    if Res.NoElements<>0 then dec(NbCasesVides);
      //si une tape prcdente a russi, alors un chiffre a t plac

    if Res.NoElements=0 then
      Res:=TesterInteraction(Grille,Occur,NoElemInteraction);
    if Res.NoElements=0 then
      Res:=TesterCandidatsJusquaNieme(Grille,Occur,NoElementNieme);
    if Res.NoElements=0 then
      Res:=TesterEtoileANBranche(Grille,Occur,ValNBranche);

    {  /!\ IMPORTANT /!\
      Pour des performances meilleures, on peut enlever la fonction TesterEtoileANBranche
      Je la laisse uniquement car j'ai pour but de simplifier la grille par logique au max
    }

    Result:=Res.NoElements<>0;

    if AfficherGrille and Result then
    begin
      Afficher;

      AfficherSurbrillance(Res);
    end;
  end;
end;




function TempsToStr(Tps : Extended):string;
begin
  if Tps<0.001 then
    Result:=FormatFloat('#####.##',Tps*1000000)+' s'
  else
  begin
    if Tps<1 then    
      Result:=FormatFloat('#####.##',Tps*1000)+' ms'
    else
      Result:=FormatFloat('#####.##',Tps)+' sec';
  end
end;




procedure ModeResolution (Mode : TSmallNum);
//Resoud la grille soit avec logique, soit avec bruteForce.
//Chronometre les actions, et affiche le message appropri.
var FFrequency    : Int64    ;    // Frquence du compteur hautes performances.
    FStart, FStop : Int64    ;    // Valeurs du compteur au dbut et  la fin du chrono.
    FElapsed      : Extended ;    // Dure finale, en secondes.

    Logique,BruteForce, ErreurGrille : boolean;
    Temps, Txt : String;
begin

  case Mode of
    1 : Begin
          Logique:=True;
          BruteForce:=False;
        end;    //logique

    2 : begin
          Logique:=False;
          BruteForce:=True;
        end;     //bruteforce

   else begin
          Logique:=True;
          BruteForce:=True;
        end;   //les 2
  end;

  ErreurGrille:=False;


  // Initialisation du compteur hautes performances, et dbut du chronomtrage.
  If Not QueryPerformanceFrequency(FFrequency) Then
    Raise Exception.Create('Pas de compteur hautes performances.');
  QueryPerformanceCounter(FStart) ;

  if Logique then
      repeat
      until not(FaireUnCoup(PointeursSudoku,Occurence,False,FSudoku.MainMenu1.Items[2].Items[0].Checked));

  if (NbCasesVides>0) and BruteForce then
      ResoudreBruteForce3(PointeursSudoku,1);


  // Fin de chronomtrage, conversion du temps coul en secondes.
  QueryPerformanceCounter(FStop) ;
  FElapsed := (FStop-FStart)/FFrequency ;


  if ErreurGrille then
    ShowMessage('La grille n''a pas de solution.')
  else
  begin
    Temps:=TempsToStr(FElapsed);
    Afficher;
    FSudoku.Etapes.Lines.Add(EtapesResolution);
    EtapesResolution:='';
    begin
      if NbCasesVides=0 then
        Txt:='Sudoku rsolu entirement par la Logique en '+Temps
      else
        begin
          if Logique then
          begin
            if BruteForce then Txt:='Sudoku rsolu par Logique et BruteForce en '+Temps
                          else Txt:='Sudoku rsolu au maximum par la Logique en '+Temps;
          end
          else
            Txt:='Sudoku rsolu par BruteForce en '+Temps;
        end;
    end;
    ShowMessage(Txt);
    FSudoku.Etapes.Lines.Add('');
    FSudoku.Etapes.Lines.Add(Txt);
  end;
end;





procedure TFSudoku.EtapeparEtape1Click(Sender: TObject);
//Resoud une tape du sudoku
//Affiche le rsultat si il y a du changement et met en surbrillance la nouvelle valeur
//Actualise les proprits enabled des boutons
begin
  ReglerTailleForm(MainMenu1.Items[2].Items[0].Checked);
  if FaireUnCoup(PointeursSudoku,Occurence,True,MainMenu1.Items[2].Items[0].Checked) then
  begin
    if EtapesResolution<>'' then
      Etapes.Lines.Add(EtapesResolution);
    EtapesResolution:='';
    Vider.Enabled:=True;
    MainMenu1.Items[1].Items[6].Enabled:=True; //Vider
  end
  else
  begin
    UnCoup.Enabled:=False;
    MainMenu1.Items[1].Items[0].Enabled:=False;
    RLogique.Enabled:=False;
    MainMenu1.Items[1].Items[2].Enabled:=False; 
    Resoudre.Enabled:=False;
    MainMenu1.Items[1].Items[1].Enabled:=False;
  end;

  if NbCasesVides=0 then
  begin
    RBruteForce.Enabled:=False;
    MainMenu1.Items[1].Items[3].Enabled:=False;
  end;
end;





procedure TFSudoku.Rsoudre1Click(Sender: TObject);
begin
  ReglerTailleForm(MainMenu1.Items[2].Items[0].Checked);

  ModeResolution(3);

  UnCoup.Enabled:=False;
  MainMenu1.Items[1].Items[0].Enabled:=False;
  Resoudre.Enabled:=False;
  MainMenu1.Items[1].Items[1].Enabled:=False;
  RLogique.Enabled:=False;
  MainMenu1.Items[1].Items[2].Enabled:=False;
  RBruteForce.Enabled:=False;
  MainMenu1.Items[1].Items[3].Enabled:=False;
  Vider.Enabled:=True;
  MainMenu1.Items[1].Items[6].Enabled:=True; //Vider
end;




procedure TFSudoku.Rsolutionlogiqueseulement1Click(Sender: TObject);
begin
  ReglerTailleForm(MainMenu1.Items[2].Items[0].Checked);

  ModeResolution(1);

  UnCoup.Enabled:=False;
  MainMenu1.Items[1].Items[0].Enabled:=False;
  RLogique.Enabled:=False;
  MainMenu1.Items[1].Items[2].Enabled:=False;  
  Vider.Enabled:=True;
  MainMenu1.Items[1].Items[6].Enabled:=True; //Vider
  Resoudre.Enabled:=False;
  MainMenu1.Items[1].Items[1].Enabled:=False;

  if NbCasesVides=0 then
  begin
    RBruteForce.Enabled:=False;
    MainMenu1.Items[1].Items[3].Enabled:=False;
  end;
end;




procedure TFSudoku.RsolutionBruteForce1Click(Sender: TObject);
begin          
  ReglerTailleForm(MainMenu1.Items[2].Items[0].Checked);

  ModeResolution(2);

  UnCoup.Enabled:=False;
  MainMenu1.Items[1].Items[0].Enabled:=False;
  Resoudre.Enabled:=False;
  MainMenu1.Items[1].Items[1].Enabled:=False;
  RLogique.Enabled:=False;
  MainMenu1.Items[1].Items[2].Enabled:=False;
  RBruteForce.Enabled:=False;
  MainMenu1.Items[1].Items[3].Enabled:=False;  
  Vider.Enabled:=True;
  MainMenu1.Items[1].Items[6].Enabled:=True; //Vider
end;





procedure TFSudoku.Edit1Change(Sender: TObject);     //a effacer
begin
  AfficherOccurence;
end;





procedure TFSudoku.Copier1Click(Sender: TObject);
var i,j : TSmallNum;
    Txt : String;
begin
  Txt:='';
  for j:=1 to TAILLE_SUDOKU do
  begin
    for i:=1 to TAILLE_SUDOKU do
      Txt:=Txt+ValeurCaseToStr(Sudoku[j,i]);
    Txt:=Txt+#13#10;
  end;
  ClipBoard.AsText:=Txt;
end;





procedure TFSudoku.Quitter1Click(Sender: TObject);
begin
  Application.Terminate;
end;


procedure TFSudoku.Aide1Click(Sender: TObject);
begin
  ShellExecute(Handle,'open',PChar('Aide Sudoku Solveur.chm'),nil,nil,SW_SHOW);
end;

end.
