unit USudokuNouveau;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls, USudoku, ClipBrd;

type
  TFNouveau = class(TForm)
    Apercu: TStringGrid;
    Ok: TButton;
    Annuler: TButton;
    Charger: TButton;
    Label1: TLabel;
    procedure AnnulerClick(Sender: TObject);
    procedure ChargerClick(Sender: TObject);
    procedure OkClick(Sender: TObject);
    procedure ApercuKeyPress(Sender: TObject; var Key: Char);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  FNouveau: TFNouveau;
  NewGridAnnule : Boolean;

implementation

{$R *.dfm}




procedure TFNouveau.ApercuKeyPress(Sender: TObject; var Key: Char);
var Select : TGridRect;
begin
  Select:=Apercu.Selection;

  if (Ord(Key)<48) or (ord(Key)>57)then
     Key:=#48;

  if (Key<>#48) then Apercu.Cells[Select.Left,Select.Top]:=Key
                else Apercu.Cells[Select.Left,Select.Top]:='';


  if Select.Left<8 then Select.Left:=Select.Left+1
  else
  if Select.Top<8 then
  begin
    Select.Left:=0;
    Select.Top:=Select.Top+1;
  end;

  Select.Right:=Select.Left;
  Select.Bottom:=Select.Top;
  Apercu.Selection:=Select;
end;






procedure TFNouveau.OkClick(Sender: TObject);
var Row, Col : integer;
begin
  SudokuInit:='';
  for Row:=0 to 8 do
  begin
    for Col:=0 to 8 do
      if Apercu.Cells[Col,Row]<>'' then SudokuInit:=SudokuInit+Apercu.Cells[Col,Row]
                                   else SudokuInit:=SudokuInit+'0';
  end;
  NewGridAnnule:=False;  
  FNouveau.Close;
  FSudoku.Enabled:=True;
  FNouveau.ModalResult:=mrOk;
end;






procedure TFNouveau.ChargerClick(Sender: TObject);
var Cases, NumChar : integer;
    Txt : String;
begin
  Txt:=ClipBoard.AsText;
  Cases:=0;                         

  for NumChar:=1 to Length(Txt) do
  begin
    if (Txt[NumChar]<>#13) and (Txt[NumChar]<>#10) then
    begin
      inc(Cases);
      if Txt[NumChar] in ['1'..'9'] then Apercu.Cells[(Cases-1) mod 9, (Cases-1) div 9]:=Txt[NumChar]
                                    else Apercu.Cells[(Cases-1) mod 9, (Cases-1) div 9]:='';
    end;
  end;
end;






procedure TFNouveau.AnnulerClick(Sender: TObject);
begin
  FNouveau.ModalResult:=mrCancel;
end;

end.
